from EasyExtend.fibers.gallery.chainlet import*
import unittest
from test import test_support

class TestChainlet(unittest.TestCase):

    def test_cond(self):
        A   = Chainlet("A")
        B   = Chainlet("B")
        A1  = A("A1")
        A11 = A1("A11")
        B1  = B("B1")
        B11 = B1("B11")
        B12 = B1("B12")

        C = A1

        self.assertEqual ( C.cond('b',A11)    , None )
        self.assertEqual ( C.cond('a',A,'b',A11)    , 'a' )
        self.assertEqual ( C.cond('a',A|A1,'b',A1)  , 'b' )
        C = A1*B11
        self.assertEqual ( C.cond('a',A ,'b',A1), 'b' )
        self.assertEqual ( C.cond('a',A*B  ,'b',A1)     , 'a' )
        self.assertEqual ( C.cond('a',A*B  ,'b',A1*B)   , 'b' )
        self.assertEqual ( C.cond('a',A1*B1,'b',A1*B)   , 'a' )
        self.assertEqual ( C.cond('a',A1*B1 ,'b',A*B11)  , 'a' )
        self.assertEqual ( C.cond('a',A*B11 ,'b',A1*B1)  , 'a' )
        self.assertEqual ( C.cond('a',A1*B1,'b',A1*B11) , 'b' )
        self.assertEqual ( C.cond('a',A11,'b',A1*B1) , 'b' )


    def test_select(self):
        A   = Chainlet("A")
        B   = Chainlet("B")
        A1  = A("A1")
        A11 = A1("A11")
        B1  = B("B1")
        B11 = B1("B11")
        B12 = B1("B12")

        C = A1

        self.assertEqual ( C.select(A,A11)    , A )
        self.assertEqual ( C.select(A|A1,A1)  , A1)
        self.assertEqual ( C.select(A1,A1|A)  , A1)
        C = A11
        self.assertEqual ( C.select(A,A1,A11|B11) , A11|B11 )
        C = A1*B11
        self.assertEqual ( C.select(A,A1)     , A1 )
        self.assertEqual ( C.select(A*B,A1)   , A*B )
        self.assertEqual ( C.select(A*B,A1*B) , A1*B)

    def test_or_and_mul(self):
        A   = Chainlet("A")
        B   = Chainlet("B")
        A1  = A("A1")
        A11 = A1("A11")
        B1  = B("B1")
        B11 = B1("B11")
        B12 = B1("B12")

        C = A1|B1
        self.assertEqual ( C.select(A1,A) , A1)
        #self.assertEqual ( C.select(A1,A1|A)  , A1)


def test_main():
    test_support.run_unittest(TestChainlet)


if __name__ == "__main__":
    test_main()

